#//Project Robot Robo-Cleaner
from tkinter import *
from tkinter import messagebox
from tkinter import ttk
import socket

from setuptools import Command

root = Tk()
root.title("Robo-Cleaner")
root.resizable(False, False)
root.geometry("900x400")

# //Socket Connection & Socket Connection Windows
client = socket.socket()
port = 12345

def get_IP():
    vtn_ip = Tk()
    vtn_ip.geometry("275x100")
    vtn_ip.resizable(False,False)
    vtn_ip.title("Ajustes de la Conexión IP")

    inform = Label(vtn_ip,text="Dirección IP: ").place(x=10, y=10)
    addr = StringVar(vtn_ip)
    ip = ttk.Entry(vtn_ip, textvariable = addr).place(x=100, y=10)
    
    boton = Button(vtn_ip, text = "Establecer", command = lambda:[conection(addr.get()+""), vtn_ip.destroy()]).place(x=98, y=50)
    print(addr.get())

def conection(addr):
    port = 12345
    try:
        client.connect((addr, port))
        messagebox.showinfo("Mensaje Recibido", "El host se conectó al robot: \nDirección IP: {0}\nPuerto: {1}".format(addr,port))
    except socket.error:
        messagebox.showwarning("Error de conexión", "No se logró realizar la conexión. \nRevise la dirección IP e intentelo nuevamente. \nDirección IP: " + addr)
        get_IP()
        client.close()


# //Functions
def Upward(event):
    client.send(bytes([ord('i')]))

def Backwards(event):
    client.send(bytes([ord('k')]))

def LeftTurn(event):
    client.send(bytes([ord('j')]))

def RightTurn(event):
    client.send(bytes([ord('l')]))

def Rotate(event):
    client.send(bytes([ord('p')]))

def Automatic():
    client.send(bytes([ord('a')]))

def disconection():
    client.send(bytes([ord('q')]))

def Halt(event):
    client.send(bytes([ord('w')]))

# //Set own directory for background image
check_photo = PhotoImage(file="checked.png")
exit_photo = PhotoImage(file="exit.png")
automatic_photo = PhotoImage(file="letter-a.png")
root_canvas = Canvas(root, width=900, height=400)
root_canvas.pack(fil="both", expand=True)
root_canvas.create_image(260, 100, image=check_photo, anchor="nw")
root_canvas.create_image(260, 140, image=exit_photo, anchor="nw")
root_canvas.create_image(260, 180, image=automatic_photo, anchor="nw")

# //Buttons of interface tkinter & labels
title_label = Label(root, text="[ Robo-Cleaner Interface ]", font=("Helvetica", 14), width=20, foreground="#757575").place(x=330, y=30)
version_label = Label(root, text="Version 1.1", font=("Helvetica", 12), width=12, foreground="#757575").place(x=120, y=340)
botton_connect = Button(root, text="Conectar", font=("Helvetica", 12), width=12, bg="RoyalBlue1", foreground="white", command=get_IP).place(x=120, y=100)
botton_disconect = Button(root, text="Desconectar", font=("Helvetica", 12), width=12, bg="RoyalBlue1", foreground="white", command=disconection).place(x=120, y=140)
botton_automatic = Button(root, text="Automatico", font=("Helvetica", 12), width=12, bg="RoyalBlue1", foreground="white",command=Automatic).place(x=120, y=180)
botton_forward = Button(root, text="Adelante", font=("Helvetica",12), width=12, bg="RoyalBlue1", foreground="white")
botton_forward.place(x=550, y=100)
botton_forward.bind('<ButtonPress>',Upward)
botton_forward.bind('<ButtonRelease>',Halt)
botton_rotate = Button(root, text="Rotar Helice", font=("Helvetica", 12), width=12, bg="RoyalBlue1", foreground="white")
botton_rotate.place(x=550, y=140)
botton_rotate.bind('<ButtonPress>',Rotate)
botton_rotate.bind('<ButtonRelease>',Halt)
botton_rotate_left = Button(root, text="Rotar Izq", font=("Helvetica", 12), width=12, bg="RoyalBlue1", foreground="white")
botton_rotate_left.place(x=420, y=140)
botton_rotate_left.bind('<ButtonPress>',LeftTurn)
botton_rotate_left.bind('<ButtonRelease>',Halt)
botton_rotate_right = Button(root, text="Rotar Dere", font=("Helvetica", 12), width=12, bg="RoyalBlue1", foreground="white")
botton_rotate_right.place(x=680, y=140)
botton_rotate_right.bind('<ButtonPress>',RightTurn)
botton_rotate_right.bind('<ButtonRelease>',Halt)
botton_backward = Button(root, text="Atras", font=("Helvetica", 12), width= 12, bg="RoyalBlue1", foreground="white")
botton_backward.place(x=550, y=180)
botton_backward.bind('<ButtonPress>',Backwards)
botton_backward.bind('<ButtonRelease>',Halt)
botton_close = Button(root, text=" Salir ", command=root.destroy, font=("Helvetica", 14), width=12).place(x=700, y=340)

#Protocols & mainloop for root
root.protocol("WM_DELETE_WINDOWS")
root.mainloop()
