#!/usr/bin/env python3
from ev3dev2.motor import SpeedPercent, MoveTank, LargeMotor, MediumMotor, OUTPUT_A, OUTPUT_B, OUTPUT_D
from ev3dev2.sensor import INPUT_1, INPUT_4
from ev3dev2.sensor.lego import UltrasonicSensor, ColorSensor

tank = MoveTank(OUTPUT_A, OUTPUT_B)

mot_rot= MediumMotor(OUTPUT_D)

prox = UltrasonicSensor(INPUT_1)


col = ColorSensor(INPUT_4)

def Automatic():
    while (col.color != 6):
        while (prox.distance_centimeters_continuous > 5):
            tank.on(left_speed= 90, right_speed= 90)
            if (col.color == 6):
                tank.off(brake=True)
                break
        else:
            tank.off(brake=True)
            mot_rot.on_for_seconds(speed = 75, seconds = 1, brake=True)
    tank.off(brake=True)

def Upward():
    tank.on(left_speed= 90, right_speed= 90)

def Backwards():
    tank.on(left_speed= -90, right_speed= -90)

def LeftTurn():
    tank.on(left_speed= 90, right_speed= -90)

def RightTurn():
    tank.on(left_speed= -90, right_speed= 90)

def Rotate():
    mot_rot.on(speed = 75, brake=True)

def Halt():
    tank.off(brake=True)
    mot_rot.off(brake=True)